"""
Authors
-------------------------------
Fernando Penaherrera **@UOL/OFFIS**

Jan Philipp Hörding **@UOL/OFFIS**

Description
-------------------------------
This set of utility functions supplements the main scenario by offering essential 
functionalities for simulation setup and data manipulation.

"""
import json
import logging
import mosaik
from src.preprocessing.prepare_thermal_system_data import create_heat_system_data
from src.common import *


def assert_configurations(world, configuration):
    
    """
    Asserts the validity of configurations for a simulation scenario.

    :param world: Mosaik world object.
    :type world: object

    :param configuration: Dictionary containing scenario configuration data.
    :type configuration: dict

    :raises ValueError: If the Mosaik world object is None or if the provided scenario or configuration values are invalid.

    :return: None. Raises ValueError for invalid configurations.

    """

    create_directories(DIRECTORIES)
    scenario = configuration["scenario"]
    STEP_SIZE = configuration["step_size"]
    N_BUILDINGS = configuration["n_buildings"]
    system_data = read_system_data()

    if world is None:
        raise ValueError("Mosaik world object is None. Wrong Scenario")

    if scenario not in [Scenarios.OP_PLAN, Scenarios.FLEX]:
        raise ValueError(f"Mosaik scenario must be {Scenarios.OP_PLAN.name} " +
                         f"or {Scenarios.FLEX.name}, but {scenario} was given")
    if STEP_SIZE != 3600:
        raise ValueError(
            f"This scenario only works for a step size of 1h (3600s),"+
            f" but {STEP_SIZE} was given")

    if N_BUILDINGS > len(system_data['building_data'].keys()):
        n_buildings_data = len(system_data['building_data'].keys())
        raise ValueError(
            f"Number of buildings is {N_BUILDINGS} but this scenario"+
            f" only works with up to {n_buildings_data} buildings")


def get_model_attrs(model):
    """Gets a list of the model attributes

    :param model: A mosaik model entity
    :type model: mosaik model object
    :return: A list with the atributes
    :rtype: list
    """  
    
    if mosaik._version.VERSION in ["3.0.0","3.1.0"]:
        attrs = list(model.sim.meta["models"].values())[0]["attrs"]
    else: 
        attrs = model.meta["attrs"]
    return attrs


def scale_system_data(system_data, scaling=1):
    """
    Scales the input system data based on the provided scaling factor.

    :param dict system_data: Dictionary containing system data.
    :param float scaling: Scaling factor. Defaults to 1.

    :return: Scaled system data dictionary.
    :rtype: dict
    """
    if scaling == 1:
        return system_data

    elif scaling != 1.0:
        for _, val in system_data['building_data'].items():
            val['max_occupancy'] *= scaling
        for _, val in system_data['heat_pump_data'].items():
            if scaling >= 2:
                val["hp_model"] = 'Air_60kW'
        for _, val in system_data['radiators_data'].items():
            val['Q_design'] *= scaling
        for _, val in system_data['tank_data'].items():
            val['diameter'] *= (scaling) ** (0.5)
            heat_rod_p_ = val['heating_rods']['hr_1']['P_th_stages']
            val['heating_rods']['hr_1']['P_th_stages'] = [
                x * scaling for x in heat_rod_p_]

        logging.info(f"System data scaled to {scaling}")

    return system_data


def read_system_data():
    """
    Reads system data from JSON files generated by the `create_heat_system_data` function.

    :return: A dictionary containing system data loaded from JSON files.
    :rtype: dict
    """
    data_dirs = create_heat_system_data()
    data_jsons = {}

    for key in data_dirs.keys():
        with open(data_dirs[key]) as json_file:
            json_data = json.load(json_file)
            data_jsons[key] = json_data

    # The values of layers in the tank params must be integers
    for key in data_jsons['tank_data'].keys():
        data_jsons['tank_data'][key]['n_layers']=int(data_jsons['tank_data'][key]['n_layers'])
        data_jsons['tank_data'][key]['n_sensors']=int(data_jsons['tank_data'][key]['n_sensors'])

    logging.info(f"Thermal system data successfully read ")

    return data_jsons